#!/bin/bash

export DISPLAY=':0.0'

compare_str="/usr/bin/fcitx
/usr/bin/dbus-daemon
/usr/bin/fcitx-dbus-watcher"

exit 0

logpath=$HOME/.cache/iflytek/ime/iflyIM_daemon.log
echo `date` "  [info] iflyIM_daemon start"  >> $logpath
isOpencc = `cat  ~/.config/fcitx/conf/fcitx-chttrans.config | grep "TransEngine=OpenCC" | wc -l`

if [ $isOpencc -gt 0 ]; then
	sed -i "s/\#TransEngine=OpenCC/TransEngine=Native/g" ~/.config/fcitx/conf/fcitx-chttrans.config
	sed -i "s/TransEngine=OpenCC/TransEngine=Native/g" ~/.config/fcitx/conf/fcitx-chttrans.config
	pids=`ps -o ruser=longlonglonglonglonglongname -e -o pid,cmd | grep -w fcitx | grep -w $(whoami) | grep -v grep | awk '{print $2}'`
	kill -9 $pids
	nohup /usr/bin/fcitx -r -D > /dev/null 2>&1 &
fi



while true;
do

	# server_fcitx=`ps -o ruser=longlonglonglonglonglongname -e -o cmd | grep -w fcitx | grep -w $(whoami) | grep -v grep | awk '{print $2}' | while read line; do echo $line | awk '{print $1}'; done;`
	# if [ "$server_fcitx" != "$compare_str" ];then
	# 	if [ "$server_fcitx" != "" ];then
	# 		pids=`ps -o ruser=longlonglonglonglonglongname -e -o pid,cmd | grep -w fcitx | grep -w $(whoami) | grep -v grep | awk '{print $2}'`
	# 		kill -9 $pids
	# 	fi
	# 	echo "fcitx is not running, ready start."
	# 	nohup /usr/bin/fcitx -r -D > /dev/null 2>&1 &
	# else
	# 	echo "fcitx is normal"
	# fi

	# # nohup /usr/bin/fcitx-autostart >/dev/null 2>&1 &
	# # Test whether fcitx is running correctly with dbus...
	# date=`date`
	# fcitx-remote > /dev/null 2>&1
	# if [ $? = "1" ]; then
	# 	echo "$date  [WARN] fcitx check err!!! " >> $logpath
	# 	sleep 1
	# 	fcitx-remote > /dev/null 2>&1
	# 	if [ $? = "1" ]; then
	# 		echo "$date  [ERROR] fcitx check err restart!!! " >> $logpath
	# 		pids=`ps -o ruser=longlonglonglonglonglongname -e -o pid,cmd | grep -w fcitx | grep -w $(whoami) | grep -v grep | awk '{print $2}'`
	#  		kill -9 $pids
	# 		nohup /usr/bin/fcitx -r -D > /dev/null 2>&1 &
	# 		#nohup /usr/bin/fcitx -r -D >$HOME/.cache/iflytek/ime/fcitx-std.log 2>&1 &
	# 	fi
	# 	sleep 2
	# else
	# 	echo "$date  [info] Fcitx is running correctly."  >> $logpath
	# fi

	server_ifly=`ps -o ruser=longlonglonglonglonglongname -e -o pid,cmd | grep -w iflyime-qimpanel | grep -w $(whoami) | grep -v grep |wc -l`
	if [ $server_ifly -eq 0 ];then
		echo `date` "  [ERROR] iflyime-qimpanel is not running, ready start."  >> $logpath
	    #gdbfind=`which gdb | wc -l`
		#if [ $gdbfind -eq 0  ]; then	
			echo `date`  "  start gdb" >> "/home/iflytek/.cache/iflytek/ime/gdb_crash.log"
			nohup /usr/bin/iflyime-qimpanel >/dev/null 2>&1 &
			##nohup /usr/bin/iflyime-qimpanel >$HOME/.cache/iflytek/ime/iflyime-qimpanel-std.log 2>&1 &
			sleep 2
		#else
		#	echo `date` "  start gdb" >> "/home/iflytek/.cache/iflytek/ime/gdb_crash.log"
		#	gdb /usr/bin/iflyime-qimpanel -x /usr/share/fcitx-iflyime/iflyime_debug.ini
		#fi

	else
		echo `date` "  [info] iflyime-qimpanel is normal"  >> $logpath
    	fi
	sleep 1
done
